/* key-event.c generated by valac 0.16.0, the Vala compiler
 * generated from key-event.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Daiki Ueno <ueno@unixuser.org>
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define SKK_TYPE_MODIFIER_TYPE (skk_modifier_type_get_type ())

#define SKK_TYPE_KEY_EVENT (skk_key_event_get_type ())
#define SKK_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_KEY_EVENT, SkkKeyEvent))
#define SKK_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_KEY_EVENT, SkkKeyEventClass))
#define SKK_IS_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_KEY_EVENT))
#define SKK_IS_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_KEY_EVENT))
#define SKK_KEY_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_KEY_EVENT, SkkKeyEventClass))

typedef struct _SkkKeyEvent SkkKeyEvent;
typedef struct _SkkKeyEventClass SkkKeyEventClass;
typedef struct _SkkKeyEventPrivate SkkKeyEventPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define SKK_TYPE_ENTRY (skk_entry_get_type ())
typedef struct _SkkEntry SkkEntry;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED,
	SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND
} SkkKeyEventFormatError;
#define SKK_KEY_EVENT_FORMAT_ERROR skk_key_event_format_error_quark ()
typedef enum  {
	SKK_MODIFIER_TYPE_NONE = 0,
	SKK_MODIFIER_TYPE_SHIFT_MASK = 1 << 0,
	SKK_MODIFIER_TYPE_LOCK_MASK = 1 << 1,
	SKK_MODIFIER_TYPE_CONTROL_MASK = 1 << 2,
	SKK_MODIFIER_TYPE_MOD1_MASK = 1 << 3,
	SKK_MODIFIER_TYPE_MOD2_MASK = 1 << 4,
	SKK_MODIFIER_TYPE_MOD3_MASK = 1 << 5,
	SKK_MODIFIER_TYPE_MOD4_MASK = 1 << 6,
	SKK_MODIFIER_TYPE_MOD5_MASK = 1 << 7,
	SKK_MODIFIER_TYPE_LSHIFT_MASK = 1 << 22,
	SKK_MODIFIER_TYPE_RSHIFT_MASK = 1 << 23,
	SKK_MODIFIER_TYPE_USLEEP_MASK = 1 << 24,
	SKK_MODIFIER_TYPE_SUPER_MASK = 1 << 26,
	SKK_MODIFIER_TYPE_HYPER_MASK = 1 << 27,
	SKK_MODIFIER_TYPE_META_MASK = 1 << 28,
	SKK_MODIFIER_TYPE_RELEASE_MASK = 1 << 30
} SkkModifierType;

struct _SkkKeyEvent {
	GObject parent_instance;
	SkkKeyEventPrivate * priv;
};

struct _SkkKeyEventClass {
	GObjectClass parent_class;
};

struct _SkkKeyEventPrivate {
	gchar* _name;
	gunichar _code;
	SkkModifierType _modifiers;
};

struct _SkkEntry {
	gpointer key;
	gpointer value;
};


static gpointer skk_key_event_parent_class = NULL;

GQuark skk_key_event_format_error_quark (void);
GType skk_modifier_type_get_type (void) G_GNUC_CONST;
GType skk_key_event_get_type (void) G_GNUC_CONST;
#define SKK_KEY_EVENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SKK_TYPE_KEY_EVENT, SkkKeyEventPrivate))
enum  {
	SKK_KEY_EVENT_DUMMY_PROPERTY,
	SKK_KEY_EVENT_NAME,
	SKK_KEY_EVENT_CODE,
	SKK_KEY_EVENT_MODIFIERS
};
GType skk_entry_get_type (void) G_GNUC_CONST;
SkkEntry* skk_entry_dup (const SkkEntry* self);
void skk_entry_free (SkkEntry* self);
void skk_entry_copy (const SkkEntry* self, SkkEntry* dest);
void skk_entry_destroy (SkkEntry* self);
#define SKK_KEYSYMS_Tab ((guint) 0xff09)
#define SKK_KEYSYMS_Return ((guint) 0xff0d)
#define SKK_KEYSYMS_BackSpace ((guint) 0xff08)
#define SKK_KEYSYMS_Up ((guint) 0xff52)
#define SKK_KEYSYMS_Down ((guint) 0xff54)
#define SKK_KEYSYMS_Left ((guint) 0xff51)
#define SKK_KEYSYMS_Right ((guint) 0xff53)
#define SKK_KEYSYMS_Page_Up ((guint) 0xff55)
#define SKK_KEYSYMS_KP_Page_Up ((guint) 0xff9a)
#define SKK_KEYSYMS_Page_Down ((guint) 0xff56)
#define SKK_KEYSYMS_KP_Page_Down ((guint) 0xff9b)
#define SKK_KEYSYMS_Muhenkan ((guint) 0xff22)
#define SKK_KEYSYMS_Henkan ((guint) 0xff23)
SkkKeyEvent* skk_key_event_new (const gchar* name, gunichar code, SkkModifierType modifiers);
SkkKeyEvent* skk_key_event_construct (GType object_type, const gchar* name, gunichar code, SkkModifierType modifiers);
static void skk_key_event_set_name (SkkKeyEvent* self, const gchar* value);
static void skk_key_event_set_code (SkkKeyEvent* self, gunichar value);
void skk_key_event_set_modifiers (SkkKeyEvent* self, SkkModifierType value);
SkkKeyEvent* skk_key_event_copy (SkkKeyEvent* self);
const gchar* skk_key_event_get_name (SkkKeyEvent* self);
gunichar skk_key_event_get_code (SkkKeyEvent* self);
SkkModifierType skk_key_event_get_modifiers (SkkKeyEvent* self);
SkkKeyEvent* skk_key_event_new_from_string (const gchar* key, GError** error);
SkkKeyEvent* skk_key_event_construct_from_string (GType object_type, const gchar* key, GError** error);
gchar* skk_key_event_to_string (SkkKeyEvent* self);
SkkKeyEvent* skk_key_event_new_from_x_keysym (guint keyval, SkkModifierType modifiers, GError** error);
SkkKeyEvent* skk_key_event_construct_from_x_keysym (GType object_type, guint keyval, SkkModifierType modifiers, GError** error);
gboolean skk_key_event_base_equal (SkkKeyEvent* self, SkkKeyEvent* key);
static void skk_key_event_finalize (GObject* obj);
static void _vala_skk_key_event_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_skk_key_event_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const SkkEntry SKK_KEY_EVENT_CODE_KEYVALS[3] = {{SKK_KEYSYMS_Tab, '\t'}, {SKK_KEYSYMS_Return, '\n'}, {SKK_KEYSYMS_BackSpace, '\b'}};
static const SkkEntry SKK_KEY_EVENT_NAME_KEYVALS[10] = {{SKK_KEYSYMS_Up, "Up"}, {SKK_KEYSYMS_Down, "Down"}, {SKK_KEYSYMS_Left, "Left"}, {SKK_KEYSYMS_Right, "Right"}, {SKK_KEYSYMS_Page_Up, "Page_Up"}, {SKK_KEYSYMS_KP_Page_Up, "Page_Up"}, {SKK_KEYSYMS_Page_Down, "Page_Down"}, {SKK_KEYSYMS_KP_Page_Down, "Page_Down"}, {SKK_KEYSYMS_Muhenkan, "lshift"}, {SKK_KEYSYMS_Henkan, "rshift"}};

GQuark skk_key_event_format_error_quark (void) {
	return g_quark_from_static_string ("skk_key_event_format_error-quark");
}


/**
     * A set of bit-flags to indicate the state of modifier keys.
     */
GType skk_modifier_type_get_type (void) {
	static volatile gsize skk_modifier_type_type_id__volatile = 0;
	if (g_once_init_enter (&skk_modifier_type_type_id__volatile)) {
		static const GEnumValue values[] = {{SKK_MODIFIER_TYPE_NONE, "SKK_MODIFIER_TYPE_NONE", "none"}, {SKK_MODIFIER_TYPE_SHIFT_MASK, "SKK_MODIFIER_TYPE_SHIFT_MASK", "shift-mask"}, {SKK_MODIFIER_TYPE_LOCK_MASK, "SKK_MODIFIER_TYPE_LOCK_MASK", "lock-mask"}, {SKK_MODIFIER_TYPE_CONTROL_MASK, "SKK_MODIFIER_TYPE_CONTROL_MASK", "control-mask"}, {SKK_MODIFIER_TYPE_MOD1_MASK, "SKK_MODIFIER_TYPE_MOD1_MASK", "mod1-mask"}, {SKK_MODIFIER_TYPE_MOD2_MASK, "SKK_MODIFIER_TYPE_MOD2_MASK", "mod2-mask"}, {SKK_MODIFIER_TYPE_MOD3_MASK, "SKK_MODIFIER_TYPE_MOD3_MASK", "mod3-mask"}, {SKK_MODIFIER_TYPE_MOD4_MASK, "SKK_MODIFIER_TYPE_MOD4_MASK", "mod4-mask"}, {SKK_MODIFIER_TYPE_MOD5_MASK, "SKK_MODIFIER_TYPE_MOD5_MASK", "mod5-mask"}, {SKK_MODIFIER_TYPE_LSHIFT_MASK, "SKK_MODIFIER_TYPE_LSHIFT_MASK", "lshift-mask"}, {SKK_MODIFIER_TYPE_RSHIFT_MASK, "SKK_MODIFIER_TYPE_RSHIFT_MASK", "rshift-mask"}, {SKK_MODIFIER_TYPE_USLEEP_MASK, "SKK_MODIFIER_TYPE_USLEEP_MASK", "usleep-mask"}, {SKK_MODIFIER_TYPE_SUPER_MASK, "SKK_MODIFIER_TYPE_SUPER_MASK", "super-mask"}, {SKK_MODIFIER_TYPE_HYPER_MASK, "SKK_MODIFIER_TYPE_HYPER_MASK", "hyper-mask"}, {SKK_MODIFIER_TYPE_META_MASK, "SKK_MODIFIER_TYPE_META_MASK", "meta-mask"}, {SKK_MODIFIER_TYPE_RELEASE_MASK, "SKK_MODIFIER_TYPE_RELEASE_MASK", "release-mask"}, {0, NULL, NULL}};
		GType skk_modifier_type_type_id;
		skk_modifier_type_type_id = g_enum_register_static ("SkkModifierType", values);
		g_once_init_leave (&skk_modifier_type_type_id__volatile, skk_modifier_type_type_id);
	}
	return skk_modifier_type_type_id__volatile;
}


/**
         * Create a key event.
         *
         * @param name a key name
         * @param code a character code
         * @param modifiers state of modifier keys
         *
         * @return a new KeyEvent
         */
SkkKeyEvent* skk_key_event_construct (GType object_type, const gchar* name, gunichar code, SkkModifierType modifiers) {
	SkkKeyEvent * self = NULL;
	const gchar* _tmp0_;
	gunichar _tmp1_;
	SkkModifierType _tmp2_;
#line 83 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
#line 86 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = name;
#line 86 "/home/ueno/devel/libskk/libskk/key-event.vala"
	skk_key_event_set_name (self, _tmp0_);
#line 87 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp1_ = code;
#line 87 "/home/ueno/devel/libskk/libskk/key-event.vala"
	skk_key_event_set_code (self, _tmp1_);
#line 88 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp2_ = modifiers;
#line 88 "/home/ueno/devel/libskk/libskk/key-event.vala"
	skk_key_event_set_modifiers (self, _tmp2_);
#line 83 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return self;
#line 198 "key-event.c"
}


SkkKeyEvent* skk_key_event_new (const gchar* name, gunichar code, SkkModifierType modifiers) {
#line 83 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return skk_key_event_construct (SKK_TYPE_KEY_EVENT, name, code, modifiers);
#line 205 "key-event.c"
}


/**
         * Create a copy of the key event.
         *
         * @return a new KeyEvent
         */
SkkKeyEvent* skk_key_event_copy (SkkKeyEvent* self) {
	SkkKeyEvent* result = NULL;
	const gchar* _tmp0_;
	gunichar _tmp1_;
	SkkModifierType _tmp2_;
	SkkKeyEvent* _tmp3_;
#line 96 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = self->priv->_name;
#line 97 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp1_ = self->priv->_code;
#line 97 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp2_ = self->priv->_modifiers;
#line 97 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp3_ = skk_key_event_new (_tmp0_, _tmp1_, _tmp2_);
#line 97 "/home/ueno/devel/libskk/libskk/key-event.vala"
	result = _tmp3_;
#line 97 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return result;
#line 234 "key-event.c"
}


/**
         * Create a key event from string.
         *
         * @param key a string representation of a key event
         *
         * @return a new KeyEvent
         */
static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	glong string_length;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_;
	gboolean _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1337 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1338 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1338 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1338 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1339 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1339 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 276 "key-event.c"
		glong _tmp3_;
		glong _tmp4_;
#line 1340 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1340 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1340 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 285 "key-event.c"
	}
#line 1342 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1342 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 291 "key-event.c"
		glong _tmp6_;
		glong _tmp7_;
#line 1343 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1343 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1343 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 300 "key-event.c"
	}
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 306 "key-event.c"
		glong _tmp10_;
		glong _tmp11_;
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 315 "key-event.c"
	} else {
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 319 "key-event.c"
	}
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp12_ = _tmp8_;
#line 1345 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp14_ = end;
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp14_ >= ((glong) 0)) {
#line 329 "key-event.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp15_ = end;
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp13_ = _tmp15_ <= _tmp16_;
#line 338 "key-event.c"
	} else {
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp13_ = FALSE;
#line 342 "key-event.c"
	}
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp17_ = _tmp13_;
#line 1346 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp17_, NULL);
#line 1347 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1347 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1347 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
#line 1348 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1348 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp21_ = end;
#line 1348 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp22_ = start;
#line 1348 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) (_tmp21_ - _tmp22_));
#line 1348 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1348 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 366 "key-event.c"
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_ = 0U;
#line 1155 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1156 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1156 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1156 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1156 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 384 "key-event.c"
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _result_;
	gchar* _tmp3_;
#line 1068 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1068 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1069 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1069 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = needle;
#line 1069 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
#line 1069 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1071 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1071 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 411 "key-event.c"
		gchar* _tmp4_;
#line 1072 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1072 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1072 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 419 "key-event.c"
	} else {
#line 1074 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = -1;
#line 1074 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 425 "key-event.c"
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1305 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1305 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 449 "key-event.c"
		glong _tmp4_;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 457 "key-event.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 469 "key-event.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1315 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 494 "key-event.c"
		glong _tmp2_;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 500 "key-event.c"
	} else {
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 504 "key-event.c"
	}
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 510 "key-event.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 522 "key-event.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 532 "key-event.c"
	}
#line 1324 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1324 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 538 "key-event.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1326 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1326 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 552 "key-event.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 562 "key-event.c"
	}
#line 1330 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1330 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 568 "key-event.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 577 "key-event.c"
	}
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 597 "key-event.c"
}


SkkKeyEvent* skk_key_event_construct_from_string (GType object_type, const gchar* key, GError** error) {
	SkkKeyEvent * self = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
#line 107 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 107 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp1_ = key;
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp2_ = g_str_has_prefix (_tmp1_, "(");
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp2_) {
#line 618 "key-event.c"
		const gchar* _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp3_ = key;
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp4_ = g_str_has_suffix (_tmp3_, ")");
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp0_ = _tmp4_;
#line 627 "key-event.c"
	} else {
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp0_ = FALSE;
#line 631 "key-event.c"
	}
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp5_ = _tmp0_;
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp5_) {
#line 637 "key-event.c"
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_ = NULL;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar** strv;
		gint strv_length1;
		gint _strv_size_;
		gint index;
		gchar** _tmp57_;
		gint _tmp57__length1;
		gint _tmp58_;
		const gchar* _tmp59_;
		gunichar _tmp60_ = 0U;
		const gchar* _tmp61_;
		gint _tmp62_ = 0;
		gunichar _tmp65_;
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp6_ = key;
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp7_ = string_slice (_tmp6_, (glong) 1, (glong) (-1));
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp8_ = _tmp7_;
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 0);
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp11_ = _tmp10_;
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp11__length1 = _vala_array_length (_tmp9_);
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp8_);
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		strv = _tmp11_;
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		strv_length1 = _tmp11__length1;
#line 109 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_strv_size_ = strv_length1;
#line 110 "/home/ueno/devel/libskk/libskk/key-event.vala"
		index = 0;
#line 679 "key-event.c"
		{
			gboolean _tmp12_;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp12_ = TRUE;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
			while (TRUE) {
#line 686 "key-event.c"
				gboolean _tmp13_;
				gint _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				const gchar* _tmp19_;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp13_ = _tmp12_;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				if (!_tmp13_) {
#line 699 "key-event.c"
					gint _tmp14_;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp14_ = index;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
					index = _tmp14_ + 1;
#line 705 "key-event.c"
				}
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp12_ = FALSE;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp15_ = index;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp16_ = strv;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp16__length1 = strv_length1;
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
				if (!(_tmp15_ < (_tmp16__length1 - 1))) {
#line 111 "/home/ueno/devel/libskk/libskk/key-event.vala"
					break;
#line 719 "key-event.c"
				}
#line 112 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp17_ = strv;
#line 112 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp17__length1 = strv_length1;
#line 112 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp18_ = index;
#line 112 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp19_ = _tmp17_[_tmp18_];
#line 112 "/home/ueno/devel/libskk/libskk/key-event.vala"
				if (g_strcmp0 (_tmp19_, "control") == 0) {
#line 731 "key-event.c"
					SkkModifierType _tmp20_;
#line 113 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp20_ = self->priv->_modifiers;
#line 113 "/home/ueno/devel/libskk/libskk/key-event.vala"
					skk_key_event_set_modifiers (self, _tmp20_ | SKK_MODIFIER_TYPE_CONTROL_MASK);
#line 737 "key-event.c"
				} else {
					gchar** _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
					const gchar* _tmp23_;
#line 114 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp21_ = strv;
#line 114 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp21__length1 = strv_length1;
#line 114 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp22_ = index;
#line 114 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp23_ = _tmp21_[_tmp22_];
#line 114 "/home/ueno/devel/libskk/libskk/key-event.vala"
					if (g_strcmp0 (_tmp23_, "meta") == 0) {
#line 753 "key-event.c"
						SkkModifierType _tmp24_;
#line 115 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_tmp24_ = self->priv->_modifiers;
#line 115 "/home/ueno/devel/libskk/libskk/key-event.vala"
						skk_key_event_set_modifiers (self, _tmp24_ | SKK_MODIFIER_TYPE_META_MASK);
#line 759 "key-event.c"
					} else {
						gchar** _tmp25_;
						gint _tmp25__length1;
						gint _tmp26_;
						const gchar* _tmp27_;
#line 116 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_tmp25_ = strv;
#line 116 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_tmp25__length1 = strv_length1;
#line 116 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_tmp26_ = index;
#line 116 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_tmp27_ = _tmp25_[_tmp26_];
#line 116 "/home/ueno/devel/libskk/libskk/key-event.vala"
						if (g_strcmp0 (_tmp27_, "hyper") == 0) {
#line 775 "key-event.c"
							SkkModifierType _tmp28_;
#line 117 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp28_ = self->priv->_modifiers;
#line 117 "/home/ueno/devel/libskk/libskk/key-event.vala"
							skk_key_event_set_modifiers (self, _tmp28_ | SKK_MODIFIER_TYPE_HYPER_MASK);
#line 781 "key-event.c"
						} else {
							gchar** _tmp29_;
							gint _tmp29__length1;
							gint _tmp30_;
							const gchar* _tmp31_;
#line 118 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp29_ = strv;
#line 118 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp29__length1 = strv_length1;
#line 118 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp30_ = index;
#line 118 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp31_ = _tmp29_[_tmp30_];
#line 118 "/home/ueno/devel/libskk/libskk/key-event.vala"
							if (g_strcmp0 (_tmp31_, "super") == 0) {
#line 797 "key-event.c"
								SkkModifierType _tmp32_;
#line 119 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp32_ = self->priv->_modifiers;
#line 119 "/home/ueno/devel/libskk/libskk/key-event.vala"
								skk_key_event_set_modifiers (self, _tmp32_ | SKK_MODIFIER_TYPE_SUPER_MASK);
#line 803 "key-event.c"
							} else {
								gchar** _tmp33_;
								gint _tmp33__length1;
								gint _tmp34_;
								const gchar* _tmp35_;
#line 120 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp33_ = strv;
#line 120 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp33__length1 = strv_length1;
#line 120 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp34_ = index;
#line 120 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp35_ = _tmp33_[_tmp34_];
#line 120 "/home/ueno/devel/libskk/libskk/key-event.vala"
								if (g_strcmp0 (_tmp35_, "alt") == 0) {
#line 819 "key-event.c"
									SkkModifierType _tmp36_;
#line 121 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp36_ = self->priv->_modifiers;
#line 121 "/home/ueno/devel/libskk/libskk/key-event.vala"
									skk_key_event_set_modifiers (self, _tmp36_ | SKK_MODIFIER_TYPE_MOD1_MASK);
#line 825 "key-event.c"
								} else {
									gchar** _tmp37_;
									gint _tmp37__length1;
									gint _tmp38_;
									const gchar* _tmp39_;
#line 122 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp37_ = strv;
#line 122 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp37__length1 = strv_length1;
#line 122 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp38_ = index;
#line 122 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp39_ = _tmp37_[_tmp38_];
#line 122 "/home/ueno/devel/libskk/libskk/key-event.vala"
									if (g_strcmp0 (_tmp39_, "lshift") == 0) {
#line 841 "key-event.c"
										SkkModifierType _tmp40_;
#line 123 "/home/ueno/devel/libskk/libskk/key-event.vala"
										_tmp40_ = self->priv->_modifiers;
#line 123 "/home/ueno/devel/libskk/libskk/key-event.vala"
										skk_key_event_set_modifiers (self, _tmp40_ | SKK_MODIFIER_TYPE_LSHIFT_MASK);
#line 847 "key-event.c"
									} else {
										gchar** _tmp41_;
										gint _tmp41__length1;
										gint _tmp42_;
										const gchar* _tmp43_;
#line 124 "/home/ueno/devel/libskk/libskk/key-event.vala"
										_tmp41_ = strv;
#line 124 "/home/ueno/devel/libskk/libskk/key-event.vala"
										_tmp41__length1 = strv_length1;
#line 124 "/home/ueno/devel/libskk/libskk/key-event.vala"
										_tmp42_ = index;
#line 124 "/home/ueno/devel/libskk/libskk/key-event.vala"
										_tmp43_ = _tmp41_[_tmp42_];
#line 124 "/home/ueno/devel/libskk/libskk/key-event.vala"
										if (g_strcmp0 (_tmp43_, "rshift") == 0) {
#line 863 "key-event.c"
											SkkModifierType _tmp44_;
#line 125 "/home/ueno/devel/libskk/libskk/key-event.vala"
											_tmp44_ = self->priv->_modifiers;
#line 125 "/home/ueno/devel/libskk/libskk/key-event.vala"
											skk_key_event_set_modifiers (self, _tmp44_ | SKK_MODIFIER_TYPE_RSHIFT_MASK);
#line 869 "key-event.c"
										} else {
											gchar** _tmp45_;
											gint _tmp45__length1;
											gint _tmp46_;
											const gchar* _tmp47_;
#line 126 "/home/ueno/devel/libskk/libskk/key-event.vala"
											_tmp45_ = strv;
#line 126 "/home/ueno/devel/libskk/libskk/key-event.vala"
											_tmp45__length1 = strv_length1;
#line 126 "/home/ueno/devel/libskk/libskk/key-event.vala"
											_tmp46_ = index;
#line 126 "/home/ueno/devel/libskk/libskk/key-event.vala"
											_tmp47_ = _tmp45_[_tmp46_];
#line 126 "/home/ueno/devel/libskk/libskk/key-event.vala"
											if (g_strcmp0 (_tmp47_, "usleep") == 0) {
#line 885 "key-event.c"
												SkkModifierType _tmp48_;
#line 127 "/home/ueno/devel/libskk/libskk/key-event.vala"
												_tmp48_ = self->priv->_modifiers;
#line 127 "/home/ueno/devel/libskk/libskk/key-event.vala"
												skk_key_event_set_modifiers (self, _tmp48_ | SKK_MODIFIER_TYPE_USLEEP_MASK);
#line 891 "key-event.c"
											} else {
												gchar** _tmp49_;
												gint _tmp49__length1;
												gint _tmp50_;
												const gchar* _tmp51_;
#line 128 "/home/ueno/devel/libskk/libskk/key-event.vala"
												_tmp49_ = strv;
#line 128 "/home/ueno/devel/libskk/libskk/key-event.vala"
												_tmp49__length1 = strv_length1;
#line 128 "/home/ueno/devel/libskk/libskk/key-event.vala"
												_tmp50_ = index;
#line 128 "/home/ueno/devel/libskk/libskk/key-event.vala"
												_tmp51_ = _tmp49_[_tmp50_];
#line 128 "/home/ueno/devel/libskk/libskk/key-event.vala"
												if (g_strcmp0 (_tmp51_, "release") == 0) {
#line 907 "key-event.c"
													SkkModifierType _tmp52_;
#line 129 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_tmp52_ = self->priv->_modifiers;
#line 129 "/home/ueno/devel/libskk/libskk/key-event.vala"
													skk_key_event_set_modifiers (self, _tmp52_ | SKK_MODIFIER_TYPE_RELEASE_MASK);
#line 913 "key-event.c"
												} else {
													gchar** _tmp53_;
													gint _tmp53__length1;
													gint _tmp54_;
													const gchar* _tmp55_;
													GError* _tmp56_;
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_tmp53_ = strv;
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_tmp53__length1 = strv_length1;
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_tmp54_ = index;
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_tmp55_ = _tmp53_[_tmp54_];
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_tmp56_ = g_error_new (SKK_KEY_EVENT_FORMAT_ERROR, SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown modifier %s", _tmp55_);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													_inner_error_ = _tmp56_;
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
													if (_inner_error_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														g_propagate_error (error, _inner_error_);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														_g_object_unref0 (self);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														return NULL;
#line 942 "key-event.c"
													} else {
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														g_clear_error (&_inner_error_);
#line 131 "/home/ueno/devel/libskk/libskk/key-event.vala"
														return NULL;
#line 952 "key-event.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
#line 135 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp57_ = strv;
#line 135 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp57__length1 = strv_length1;
#line 135 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp58_ = index;
#line 135 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp59_ = _tmp57_[_tmp58_];
#line 135 "/home/ueno/devel/libskk/libskk/key-event.vala"
		skk_key_event_set_name (self, _tmp59_);
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp61_ = self->priv->_name;
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp62_ = g_utf8_strlen (_tmp61_, (gssize) (-1));
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if (_tmp62_ == 1) {
#line 981 "key-event.c"
			const gchar* _tmp63_;
			gunichar _tmp64_ = 0U;
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp63_ = self->priv->_name;
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp64_ = string_get_char (_tmp63_, (glong) 0);
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp60_ = _tmp64_;
#line 990 "key-event.c"
		} else {
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp60_ = (gunichar) '\0';
#line 994 "key-event.c"
		}
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp65_ = _tmp60_;
#line 136 "/home/ueno/devel/libskk/libskk/key-event.vala"
		skk_key_event_set_code (self, _tmp65_);
#line 108 "/home/ueno/devel/libskk/libskk/key-event.vala"
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 1002 "key-event.c"
	} else {
		const gchar* _tmp66_;
		gint _tmp67_ = 0;
		gint index;
		gint _tmp68_;
#line 139 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp66_ = key;
#line 139 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp67_ = string_last_index_of (_tmp66_, "-", 0);
#line 139 "/home/ueno/devel/libskk/libskk/key-event.vala"
		index = _tmp67_;
#line 140 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp68_ = index;
#line 140 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if (_tmp68_ > 0) {
#line 1018 "key-event.c"
			const gchar* _tmp69_;
			gint _tmp70_;
			gchar* _tmp71_ = NULL;
			gchar* _tmp72_;
			gchar** _tmp73_;
			gchar** _tmp74_ = NULL;
			gchar** _tmp75_;
			gint _tmp75__length1;
			gchar** mods;
			gint mods_length1;
			gint _mods_size_;
			gchar** _tmp76_;
			gint _tmp76__length1;
			const gchar* _tmp86_;
			gint _tmp87_;
			gchar* _tmp88_ = NULL;
			gchar* _tmp89_;
			gunichar _tmp90_ = 0U;
			const gchar* _tmp91_;
			gint _tmp92_ = 0;
			gunichar _tmp95_;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp69_ = key;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp70_ = index;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp71_ = string_substring (_tmp69_, (glong) 0, (glong) _tmp70_);
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp72_ = _tmp71_;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp74_ = _tmp73_ = g_strsplit (_tmp72_, "-", 0);
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp75_ = _tmp74_;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp75__length1 = _vala_array_length (_tmp73_);
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_g_free0 (_tmp72_);
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			mods = _tmp75_;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			mods_length1 = _tmp75__length1;
#line 142 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_mods_size_ = mods_length1;
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp76_ = mods;
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp76__length1 = mods_length1;
#line 1066 "key-event.c"
			{
				gchar** mod_collection = NULL;
				gint mod_collection_length1 = 0;
				gint _mod_collection_size_ = 0;
				gint mod_it = 0;
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
				mod_collection = _tmp76_;
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
				mod_collection_length1 = _tmp76__length1;
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
				for (mod_it = 0; mod_it < _tmp76__length1; mod_it = mod_it + 1) {
#line 1078 "key-event.c"
					gchar* _tmp77_;
					gchar* mod = NULL;
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp77_ = g_strdup (mod_collection[mod_it]);
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
					mod = _tmp77_;
#line 1085 "key-event.c"
					{
						const gchar* _tmp78_;
#line 144 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_tmp78_ = mod;
#line 144 "/home/ueno/devel/libskk/libskk/key-event.vala"
						if (g_strcmp0 (_tmp78_, "C") == 0) {
#line 1092 "key-event.c"
							SkkModifierType _tmp79_;
#line 145 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp79_ = self->priv->_modifiers;
#line 145 "/home/ueno/devel/libskk/libskk/key-event.vala"
							skk_key_event_set_modifiers (self, _tmp79_ | SKK_MODIFIER_TYPE_CONTROL_MASK);
#line 1098 "key-event.c"
						} else {
							const gchar* _tmp80_;
#line 146 "/home/ueno/devel/libskk/libskk/key-event.vala"
							_tmp80_ = mod;
#line 146 "/home/ueno/devel/libskk/libskk/key-event.vala"
							if (g_strcmp0 (_tmp80_, "A") == 0) {
#line 1105 "key-event.c"
								SkkModifierType _tmp81_;
#line 147 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp81_ = self->priv->_modifiers;
#line 147 "/home/ueno/devel/libskk/libskk/key-event.vala"
								skk_key_event_set_modifiers (self, _tmp81_ | SKK_MODIFIER_TYPE_MOD1_MASK);
#line 1111 "key-event.c"
							} else {
								const gchar* _tmp82_;
#line 148 "/home/ueno/devel/libskk/libskk/key-event.vala"
								_tmp82_ = mod;
#line 148 "/home/ueno/devel/libskk/libskk/key-event.vala"
								if (g_strcmp0 (_tmp82_, "M") == 0) {
#line 1118 "key-event.c"
									SkkModifierType _tmp83_;
#line 149 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp83_ = self->priv->_modifiers;
#line 149 "/home/ueno/devel/libskk/libskk/key-event.vala"
									skk_key_event_set_modifiers (self, _tmp83_ | SKK_MODIFIER_TYPE_META_MASK);
#line 1124 "key-event.c"
								} else {
									const gchar* _tmp84_;
#line 150 "/home/ueno/devel/libskk/libskk/key-event.vala"
									_tmp84_ = mod;
#line 150 "/home/ueno/devel/libskk/libskk/key-event.vala"
									if (g_strcmp0 (_tmp84_, "G") == 0) {
#line 1131 "key-event.c"
										SkkModifierType _tmp85_;
#line 151 "/home/ueno/devel/libskk/libskk/key-event.vala"
										_tmp85_ = self->priv->_modifiers;
#line 151 "/home/ueno/devel/libskk/libskk/key-event.vala"
										skk_key_event_set_modifiers (self, _tmp85_ | SKK_MODIFIER_TYPE_MOD5_MASK);
#line 1137 "key-event.c"
									}
								}
							}
						}
#line 143 "/home/ueno/devel/libskk/libskk/key-event.vala"
						_g_free0 (mod);
#line 1144 "key-event.c"
					}
				}
			}
#line 154 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp86_ = key;
#line 154 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp87_ = index;
#line 154 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp88_ = string_substring (_tmp86_, (glong) (_tmp87_ + 1), (glong) (-1));
#line 154 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp89_ = _tmp88_;
#line 154 "/home/ueno/devel/libskk/libskk/key-event.vala"
			skk_key_event_set_name (self, _tmp89_);
#line 154 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_g_free0 (_tmp89_);
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp91_ = self->priv->_name;
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp92_ = g_utf8_strlen (_tmp91_, (gssize) (-1));
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
			if (_tmp92_ == 1) {
#line 1166 "key-event.c"
				const gchar* _tmp93_;
				gunichar _tmp94_ = 0U;
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp93_ = self->priv->_name;
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp94_ = string_get_char (_tmp93_, (glong) 0);
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp90_ = _tmp94_;
#line 1175 "key-event.c"
			} else {
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp90_ = (gunichar) '\0';
#line 1179 "key-event.c"
			}
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp95_ = _tmp90_;
#line 155 "/home/ueno/devel/libskk/libskk/key-event.vala"
			skk_key_event_set_code (self, _tmp95_);
#line 140 "/home/ueno/devel/libskk/libskk/key-event.vala"
			mods = (_vala_array_free (mods, mods_length1, (GDestroyNotify) g_free), NULL);
#line 1187 "key-event.c"
		} else {
			const gchar* _tmp96_;
			gunichar _tmp97_ = 0U;
			const gchar* _tmp98_;
			gint _tmp99_ = 0;
			gunichar _tmp102_;
#line 157 "/home/ueno/devel/libskk/libskk/key-event.vala"
			skk_key_event_set_modifiers (self, SKK_MODIFIER_TYPE_NONE);
#line 158 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp96_ = key;
#line 158 "/home/ueno/devel/libskk/libskk/key-event.vala"
			skk_key_event_set_name (self, _tmp96_);
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp98_ = self->priv->_name;
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp99_ = g_utf8_strlen (_tmp98_, (gssize) (-1));
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
			if (_tmp99_ == 1) {
#line 1206 "key-event.c"
				const gchar* _tmp100_;
				gunichar _tmp101_ = 0U;
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp100_ = self->priv->_name;
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp101_ = string_get_char (_tmp100_, (glong) 0);
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp97_ = _tmp101_;
#line 1215 "key-event.c"
			} else {
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp97_ = (gunichar) '\0';
#line 1219 "key-event.c"
			}
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp102_ = _tmp97_;
#line 159 "/home/ueno/devel/libskk/libskk/key-event.vala"
			skk_key_event_set_code (self, _tmp102_);
#line 1225 "key-event.c"
		}
	}
#line 107 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return self;
#line 1230 "key-event.c"
}


SkkKeyEvent* skk_key_event_new_from_string (const gchar* key, GError** error) {
#line 107 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return skk_key_event_construct_from_string (SKK_TYPE_KEY_EVENT, key, error);
#line 1237 "key-event.c"
}


/**
         * Convert the KeyEvent to string.
         *
         * @return a string representing the KeyEvent
         */
static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* str;
	const gchar* _tmp1_;
#line 841 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 841 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 842 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = str;
#line 842 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_unichar_to_utf8 (self, _tmp1_);
#line 843 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = str;
#line 843 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 1263 "key-event.c"
}


gchar* skk_key_event_to_string (SkkKeyEvent* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _base;
	SkkModifierType _tmp8_;
#line 169 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp1_ = self->priv->_name;
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp1_ != NULL) {
#line 1281 "key-event.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp2_ = self->priv->_name;
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp0_);
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp0_ = _tmp3_;
#line 1292 "key-event.c"
	} else {
		gunichar _tmp4_;
		gchar* _tmp5_ = NULL;
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp4_ = self->priv->_code;
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp5_ = g_unichar_to_string (_tmp4_);
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp0_);
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp0_ = _tmp5_;
#line 1304 "key-event.c"
	}
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp6_ = _tmp0_;
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 170 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_base = _tmp7_;
#line 171 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp8_ = self->priv->_modifiers;
#line 171 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp8_ != 0) {
#line 1316 "key-event.c"
		GeeArrayList* _tmp9_;
		GeeArrayList* elements;
		SkkModifierType _tmp10_;
		SkkModifierType _tmp12_;
		SkkModifierType _tmp14_;
		SkkModifierType _tmp16_;
		SkkModifierType _tmp18_;
		SkkModifierType _tmp20_;
		SkkModifierType _tmp22_;
		SkkModifierType _tmp24_;
		SkkModifierType _tmp26_;
		GeeArrayList* _tmp28_;
		const gchar* _tmp29_;
		GeeArrayList* _tmp30_;
		GeeArrayList* _tmp31_;
		gint _tmp32_ = 0;
		gpointer* _tmp33_ = NULL;
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_ = NULL;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 172 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp9_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 172 "/home/ueno/devel/libskk/libskk/key-event.vala"
		elements = _tmp9_;
#line 173 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp10_ = self->priv->_modifiers;
#line 173 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp10_ & SKK_MODIFIER_TYPE_CONTROL_MASK) != 0) {
#line 1350 "key-event.c"
			GeeArrayList* _tmp11_;
#line 174 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp11_ = elements;
#line 174 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, "control");
#line 1356 "key-event.c"
		}
#line 176 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp12_ = self->priv->_modifiers;
#line 176 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp12_ & SKK_MODIFIER_TYPE_META_MASK) != 0) {
#line 1362 "key-event.c"
			GeeArrayList* _tmp13_;
#line 177 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp13_ = elements;
#line 177 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, "meta");
#line 1368 "key-event.c"
		}
#line 179 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp14_ = self->priv->_modifiers;
#line 179 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp14_ & SKK_MODIFIER_TYPE_HYPER_MASK) != 0) {
#line 1374 "key-event.c"
			GeeArrayList* _tmp15_;
#line 180 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp15_ = elements;
#line 180 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, "hyper");
#line 1380 "key-event.c"
		}
#line 182 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp16_ = self->priv->_modifiers;
#line 182 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp16_ & SKK_MODIFIER_TYPE_SUPER_MASK) != 0) {
#line 1386 "key-event.c"
			GeeArrayList* _tmp17_;
#line 183 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp17_ = elements;
#line 183 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, "super");
#line 1392 "key-event.c"
		}
#line 185 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp18_ = self->priv->_modifiers;
#line 185 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp18_ & SKK_MODIFIER_TYPE_MOD1_MASK) != 0) {
#line 1398 "key-event.c"
			GeeArrayList* _tmp19_;
#line 186 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp19_ = elements;
#line 186 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, "alt");
#line 1404 "key-event.c"
		}
#line 188 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp20_ = self->priv->_modifiers;
#line 188 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp20_ & SKK_MODIFIER_TYPE_LSHIFT_MASK) != 0) {
#line 1410 "key-event.c"
			GeeArrayList* _tmp21_;
#line 189 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp21_ = elements;
#line 189 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, "lshift");
#line 1416 "key-event.c"
		}
#line 191 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp22_ = self->priv->_modifiers;
#line 191 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp22_ & SKK_MODIFIER_TYPE_RSHIFT_MASK) != 0) {
#line 1422 "key-event.c"
			GeeArrayList* _tmp23_;
#line 192 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp23_ = elements;
#line 192 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, "rshift");
#line 1428 "key-event.c"
		}
#line 194 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp24_ = self->priv->_modifiers;
#line 194 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp24_ & SKK_MODIFIER_TYPE_USLEEP_MASK) != 0) {
#line 1434 "key-event.c"
			GeeArrayList* _tmp25_;
#line 195 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp25_ = elements;
#line 195 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, "usleep");
#line 1440 "key-event.c"
		}
#line 197 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp26_ = self->priv->_modifiers;
#line 197 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if ((_tmp26_ & SKK_MODIFIER_TYPE_RELEASE_MASK) != 0) {
#line 1446 "key-event.c"
			GeeArrayList* _tmp27_;
#line 198 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp27_ = elements;
#line 198 "/home/ueno/devel/libskk/libskk/key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, "release");
#line 1452 "key-event.c"
		}
#line 200 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp28_ = elements;
#line 200 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp29_ = _base;
#line 200 "/home/ueno/devel/libskk/libskk/key-event.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 201 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp30_ = elements;
#line 201 "/home/ueno/devel/libskk/libskk/key-event.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, NULL);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp31_ = elements;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp33_ = gee_abstract_collection_to_array ((GeeAbstractCollection*) _tmp31_, &_tmp32_);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp34_ = _tmp33_;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp34__length1 = _tmp32_;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp35_ = g_strjoinv (" ", _tmp34_);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp36_ = _tmp35_;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp37_ = g_strconcat ("(", _tmp36_, NULL);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp38_ = _tmp37_;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp39_ = g_strconcat (_tmp38_, ")", NULL);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp40_ = _tmp39_;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp38_);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp36_);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		result = _tmp40_;
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_object_unref0 (elements);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_base);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp0_);
#line 202 "/home/ueno/devel/libskk/libskk/key-event.vala"
		return result;
#line 1500 "key-event.c"
	} else {
#line 204 "/home/ueno/devel/libskk/libskk/key-event.vala"
		result = _base;
#line 204 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_g_free0 (_tmp0_);
#line 204 "/home/ueno/devel/libskk/libskk/key-event.vala"
		return result;
#line 1508 "key-event.c"
	}
#line 169 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_g_free0 (_base);
#line 169 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_g_free0 (_tmp0_);
#line 1514 "key-event.c"
}


/**
         * Create a key event from an X keysym and modifiers.
         *
         * @param keyval an X keysym
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
SkkKeyEvent* skk_key_event_construct_from_x_keysym (GType object_type, guint keyval, SkkModifierType modifiers, GError** error) {
	SkkKeyEvent * self = NULL;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gboolean _tmp13_;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	gboolean _tmp17_;
	SkkModifierType _tmp25_;
	GError * _inner_error_ = NULL;
#line 235 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
#line 1538 "key-event.c"
	{
		SkkEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 237 "/home/ueno/devel/libskk/libskk/key-event.vala"
		entry_collection = SKK_KEY_EVENT_NAME_KEYVALS;
#line 237 "/home/ueno/devel/libskk/libskk/key-event.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_KEY_EVENT_NAME_KEYVALS);
#line 237 "/home/ueno/devel/libskk/libskk/key-event.vala"
		for (entry_it = 0; entry_it < G_N_ELEMENTS (SKK_KEY_EVENT_NAME_KEYVALS); entry_it = entry_it + 1) {
#line 1550 "key-event.c"
			SkkEntry entry = {0};
#line 237 "/home/ueno/devel/libskk/libskk/key-event.vala"
			entry = entry_collection[entry_it];
#line 1554 "key-event.c"
			{
				SkkEntry _tmp0_;
				gconstpointer _tmp1_;
				guint _tmp2_;
#line 238 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp0_ = entry;
#line 238 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp1_ = _tmp0_.key;
#line 238 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp2_ = keyval;
#line 238 "/home/ueno/devel/libskk/libskk/key-event.vala"
				if (GPOINTER_TO_UINT (_tmp1_) == _tmp2_) {
#line 1567 "key-event.c"
					SkkEntry _tmp3_;
					gconstpointer _tmp4_;
#line 239 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp3_ = entry;
#line 239 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp4_ = _tmp3_.value;
#line 239 "/home/ueno/devel/libskk/libskk/key-event.vala"
					skk_key_event_set_name (self, (const gchar*) _tmp4_);
#line 240 "/home/ueno/devel/libskk/libskk/key-event.vala"
					break;
#line 1578 "key-event.c"
				}
			}
		}
	}
	{
		SkkEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 243 "/home/ueno/devel/libskk/libskk/key-event.vala"
		entry_collection = SKK_KEY_EVENT_CODE_KEYVALS;
#line 243 "/home/ueno/devel/libskk/libskk/key-event.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_KEY_EVENT_CODE_KEYVALS);
#line 243 "/home/ueno/devel/libskk/libskk/key-event.vala"
		for (entry_it = 0; entry_it < G_N_ELEMENTS (SKK_KEY_EVENT_CODE_KEYVALS); entry_it = entry_it + 1) {
#line 1594 "key-event.c"
			SkkEntry entry = {0};
#line 243 "/home/ueno/devel/libskk/libskk/key-event.vala"
			entry = entry_collection[entry_it];
#line 1598 "key-event.c"
			{
				SkkEntry _tmp5_;
				gconstpointer _tmp6_;
				guint _tmp7_;
#line 244 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp5_ = entry;
#line 244 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp6_ = _tmp5_.key;
#line 244 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_tmp7_ = keyval;
#line 244 "/home/ueno/devel/libskk/libskk/key-event.vala"
				if (GPOINTER_TO_UINT (_tmp6_) == _tmp7_) {
#line 1611 "key-event.c"
					SkkEntry _tmp8_;
					gconstpointer _tmp9_;
#line 245 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp8_ = entry;
#line 245 "/home/ueno/devel/libskk/libskk/key-event.vala"
					_tmp9_ = _tmp8_.value;
#line 245 "/home/ueno/devel/libskk/libskk/key-event.vala"
					skk_key_event_set_code (self, GPOINTER_TO_INT (_tmp9_));
#line 246 "/home/ueno/devel/libskk/libskk/key-event.vala"
					break;
#line 1622 "key-event.c"
				}
			}
		}
	}
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp11_ = self->priv->_name;
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp11_ == NULL) {
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp10_ = TRUE;
#line 1633 "key-event.c"
	} else {
		gunichar _tmp12_;
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp12_ = self->priv->_code;
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp10_ = _tmp12_ == ((gunichar) '\0');
#line 1640 "key-event.c"
	}
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp13_ = _tmp10_;
#line 249 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_assert (_tmp13_);
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp15_ = self->priv->_name;
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp15_ == NULL) {
#line 1650 "key-event.c"
		gunichar _tmp16_;
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp16_ = self->priv->_code;
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp14_ = _tmp16_ == ((gunichar) '\0');
#line 1656 "key-event.c"
	} else {
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp14_ = FALSE;
#line 1660 "key-event.c"
	}
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp17_ = _tmp14_;
#line 250 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp17_) {
#line 1666 "key-event.c"
		gboolean _tmp18_ = FALSE;
		guint _tmp19_;
		gboolean _tmp21_;
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp19_ = keyval;
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if (((guint) 0x20) <= _tmp19_) {
#line 1674 "key-event.c"
			guint _tmp20_;
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp20_ = keyval;
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp18_ = _tmp20_ < ((guint) 0x7F);
#line 1680 "key-event.c"
		} else {
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp18_ = FALSE;
#line 1684 "key-event.c"
		}
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp21_ = _tmp18_;
#line 251 "/home/ueno/devel/libskk/libskk/key-event.vala"
		if (_tmp21_) {
#line 1690 "key-event.c"
			guint _tmp22_;
#line 252 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp22_ = keyval;
#line 252 "/home/ueno/devel/libskk/libskk/key-event.vala"
			skk_key_event_set_code (self, (gunichar) _tmp22_);
#line 1696 "key-event.c"
		} else {
			guint _tmp23_;
			GError* _tmp24_;
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp23_ = keyval;
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_tmp24_ = g_error_new (SKK_KEY_EVENT_FORMAT_ERROR, SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND, "unknown keysym %u", _tmp23_);
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
			_inner_error_ = _tmp24_;
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
			if (_inner_error_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
				g_propagate_error (error, _inner_error_);
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
				_g_object_unref0 (self);
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
				return NULL;
#line 1714 "key-event.c"
			} else {
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
				g_clear_error (&_inner_error_);
#line 254 "/home/ueno/devel/libskk/libskk/key-event.vala"
				return NULL;
#line 1722 "key-event.c"
			}
		}
	}
#line 258 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp25_ = modifiers;
#line 258 "/home/ueno/devel/libskk/libskk/key-event.vala"
	skk_key_event_set_modifiers (self, _tmp25_);
#line 235 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return self;
#line 1732 "key-event.c"
}


SkkKeyEvent* skk_key_event_new_from_x_keysym (guint keyval, SkkModifierType modifiers, GError** error) {
#line 235 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return skk_key_event_construct_from_x_keysym (SKK_TYPE_KEY_EVENT, keyval, modifiers, error);
#line 1739 "key-event.c"
}


/**
         * Compare two key events ignoring modifiers.
         *
         * @param key a KeyEvent
         *
         * @return `true` if those base components are equal, `false` otherwise
         */
gboolean skk_key_event_base_equal (SkkKeyEvent* self, SkkKeyEvent* key) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gunichar _tmp1_;
	SkkKeyEvent* _tmp2_;
	gunichar _tmp3_;
	gboolean _tmp7_;
#line 268 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp1_ = self->priv->_code;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp2_ = key;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp3_ = _tmp2_->priv->_code;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	if (_tmp1_ == _tmp3_) {
#line 1769 "key-event.c"
		const gchar* _tmp4_;
		SkkKeyEvent* _tmp5_;
		const gchar* _tmp6_;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp4_ = self->priv->_name;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp5_ = key;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp6_ = _tmp5_->priv->_name;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp6_) == 0;
#line 1781 "key-event.c"
	} else {
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
		_tmp0_ = FALSE;
#line 1785 "key-event.c"
	}
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp7_ = _tmp0_;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	result = _tmp7_;
#line 269 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return result;
#line 1793 "key-event.c"
}


const gchar* skk_key_event_get_name (SkkKeyEvent* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = self->priv->_name;
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	result = _tmp0_;
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return result;
#line 1808 "key-event.c"
}


static void skk_key_event_set_name (SkkKeyEvent* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_if_fail (self != NULL);
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = value;
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_g_free0 (self->priv->_name);
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self->priv->_name = _tmp1_;
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_object_notify ((GObject *) self, "name");
#line 1827 "key-event.c"
}


gunichar skk_key_event_get_code (SkkKeyEvent* self) {
	gunichar result;
	gunichar _tmp0_;
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = self->priv->_code;
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	result = _tmp0_;
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return result;
#line 1842 "key-event.c"
}


static void skk_key_event_set_code (SkkKeyEvent* self, gunichar value) {
	gunichar _tmp0_;
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_if_fail (self != NULL);
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = value;
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self->priv->_code = _tmp0_;
#line 67 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_object_notify ((GObject *) self, "code");
#line 1856 "key-event.c"
}


SkkModifierType skk_key_event_get_modifiers (SkkKeyEvent* self) {
	SkkModifierType result;
	SkkModifierType _tmp0_;
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = self->priv->_modifiers;
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	result = _tmp0_;
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	return result;
#line 1871 "key-event.c"
}


void skk_key_event_set_modifiers (SkkKeyEvent* self, SkkModifierType value) {
	SkkModifierType _tmp0_;
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_return_if_fail (self != NULL);
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_tmp0_ = value;
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self->priv->_modifiers = _tmp0_;
#line 72 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_object_notify ((GObject *) self, "modifiers");
#line 1885 "key-event.c"
}


static void skk_key_event_class_init (SkkKeyEventClass * klass) {
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	skk_key_event_parent_class = g_type_class_peek_parent (klass);
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_type_class_add_private (klass, sizeof (SkkKeyEventPrivate));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_key_event_get_property;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_skk_key_event_set_property;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_key_event_finalize;
#line 1900 "key-event.c"
	/**
	         * The base name of the KeyEvent.
	         *
	         * This is exclusive to {@link code}.
	         */
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1908 "key-event.c"
	/**
	         * The base code of the KeyEvent.
	         *
	         * This is exclusive to {@link name}.
	         */
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_CODE, g_param_spec_uint ("code", "code", "code", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1916 "key-event.c"
	/**
	         * Modifier mask.
	         */
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_MODIFIERS, g_param_spec_enum ("modifiers", "modifiers", "modifiers", SKK_TYPE_MODIFIER_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1922 "key-event.c"
}


static void skk_key_event_instance_init (SkkKeyEvent * self) {
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self->priv = SKK_KEY_EVENT_GET_PRIVATE (self);
#line 1929 "key-event.c"
}


static void skk_key_event_finalize (GObject* obj) {
	SkkKeyEvent * self;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	self = SKK_KEY_EVENT (obj);
#line 60 "/home/ueno/devel/libskk/libskk/key-event.vala"
	_g_free0 (self->priv->_name);
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	G_OBJECT_CLASS (skk_key_event_parent_class)->finalize (obj);
#line 1941 "key-event.c"
}


/**
     * Object representing a key event.
     */
GType skk_key_event_get_type (void) {
	static volatile gsize skk_key_event_type_id__volatile = 0;
	if (g_once_init_enter (&skk_key_event_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SkkKeyEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_key_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkKeyEvent), 0, (GInstanceInitFunc) skk_key_event_instance_init, NULL };
		GType skk_key_event_type_id;
		skk_key_event_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkKeyEvent", &g_define_type_info, 0);
		g_once_init_leave (&skk_key_event_type_id__volatile, skk_key_event_type_id);
	}
	return skk_key_event_type_id__volatile;
}


static void _vala_skk_key_event_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SkkKeyEvent * self;
	self = SKK_KEY_EVENT (object);
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	switch (property_id) {
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		case SKK_KEY_EVENT_NAME:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		g_value_set_string (value, skk_key_event_get_name (self));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		case SKK_KEY_EVENT_CODE:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		g_value_set_uint (value, skk_key_event_get_code (self));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		case SKK_KEY_EVENT_MODIFIERS:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		g_value_set_enum (value, skk_key_event_get_modifiers (self));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 1983 "key-event.c"
		default:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 1989 "key-event.c"
	}
}


static void _vala_skk_key_event_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SkkKeyEvent * self;
	self = SKK_KEY_EVENT (object);
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
	switch (property_id) {
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		case SKK_KEY_EVENT_NAME:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		skk_key_event_set_name (self, g_value_get_string (value));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		case SKK_KEY_EVENT_CODE:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		skk_key_event_set_code (self, g_value_get_uint (value));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		case SKK_KEY_EVENT_MODIFIERS:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		skk_key_event_set_modifiers (self, g_value_get_enum (value));
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 2017 "key-event.c"
		default:
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "/home/ueno/devel/libskk/libskk/key-event.vala"
		break;
#line 2023 "key-event.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



